From 27536f985505052197f1ff7ad74d492d8bf1ca39 Mon Sep 17 00:00:00 2001
From: "Thierry bordaz (tbordaz)" <tbordaz@redhat.com>
Date: Mon, 6 Jan 2014 17:26:05 +0100
Subject: [PATCH] Ticket  47600 : Replica/Agreement/Changelog not conform to
 the design

Bug Description:
	Currently all replication functions are in brooker/__ini__.
	To conform the design, we need to split these functions into various classes
	Replica/Agreement/Changelog (and files) and to remove them from brooker/__init__.
	Also to change the interfaces (list/create/delete/set/get..).

Fix Description:
	Move

https://fedorahosted.org/389/ticket/47600

Reviewed by: ?

Platforms tested: F17

Flag Day: no

Doc impact: no
---
 lib389/__init__.py   |  81 +-----
 lib389/_constants.py |  29 +-
 lib389/_entry.py     |  34 +++
 lib389/agreement.py  | 626 ++++++++++++++++++++++++++++++++++++++++
 lib389/brooker.py    | 798 ---------------------------------------------------
 lib389/changelog.py  |  96 +++++++
 lib389/properties.py | 156 ++++++++--
 lib389/replica.py    | 550 +++++++++++++++++++++++++++++++++++
 lib389/suffix.py     |   8 +
 9 files changed, 1479 insertions(+), 899 deletions(-)
 create mode 100644 lib389/agreement.py
 create mode 100644 lib389/changelog.py
 create mode 100644 lib389/replica.py

diff --git a/lib389/__init__.py b/lib389/__init__.py
index 60ac2f2..6e2b357 100644
--- a/lib389/__init__.py
+++ b/lib389/__init__.py
@@ -45,6 +45,8 @@ from ldap.cidict import cidict
 from ldap import LDAPError
 # file in this package
 
+
+
 from lib389._constants import *
 from lib389._entry import Entry
 from lib389._replication import CSN, RUV
@@ -297,16 +299,18 @@ class DirSrv(SimpleLDAPObject):
 
     def __add_brookers__(self):
         from lib389.brooker import (
-            Agreement,
-            Replica,
             Config,
             Index)
         from lib389.mappingTree import MappingTree
-        from lib389.backend import Backend
-        from lib389.suffix import Suffix
+        from lib389.backend     import Backend
+        from lib389.suffix      import Suffix
+        from lib389.replica     import Replica
+        from lib389.changelog   import Changelog
+        from lib389.agreement   import Agreement
         
         self.agreement   = Agreement(self)
         self.replica     = Replica(self)
+        self.changelog   = Changelog(self)
         self.backend     = Backend(self)
         self.config      = Config(self)
         self.index       = Index(self)
@@ -1878,74 +1882,7 @@ class DirSrv(SimpleLDAPObject):
     def startReplication(self, agmtdn):
         return self.replica.start_and_wait(agmtdn)
 
-    def enableReplication(self, suffix=None, role=None, replicaId=CONSUMER_REPLICAID, binddn=None):
-        if not suffix:
-            log.fatal("enableReplication: suffix not specified")
-            raise ValueError("suffix missing")
-        
-        if not role:
-            log.fatal("enableReplication: replica role not specify (REPLICAROLE_*)")
-            raise ValueError("role missing")
-        
-        # 
-        # Check the validity of the parameters
-        #
-        
-        # First role and replicaID
-        if role != REPLICAROLE_MASTER and role != REPLICAROLE_HUB and role != REPLICAROLE_CONSUMER:
-            log.fatal("enableReplication: replica role invalid (%s) " % role)
-            raise ValueError("invalid role: %s" % role)
-        
-            # master
-            replica_type = REPLICA_RDWR_TYPE
-        else:
-            # hub or consumer
-            replica_type = REPLICA_RDONLY_TYPE
-        
-        if role == REPLICAROLE_MASTER:
-            # check the replicaId [1..CONSUMER_REPLICAID[
-            if not decimal.Decimal(replicaId) or (replicaId <= 0) or (replicaId >=CONSUMER_REPLICAID):
-                log.fatal("enableReplication: invalid replicaId (%s) for a RW replica" % replicaId)
-                raise ValueError("invalid replicaId %d (expected [1..CONSUMER_REPLICAID[" % replicaId)
-        elif replicaId != CONSUMER_REPLICAID:
-            # check the replicaId is CONSUMER_REPLICAID
-            log.fatal("enableReplication: invalid replicaId (%s) for a Read replica (expected %d)" % (replicaId, CONSUMER_REPLICAID))
-            raise ValueError("invalid replicaId: %d for HUB/CONSUMER replicaId is CONSUMER_REPLICAID" % replicaId)
-            
-        # Now check we have a suffix
-        entries_backend = self.backend.list(suffix=suffix)
-        if not entries_backend:
-            log.fatal("enableReplication: enable to retrieve the backend for %s" % suffix)
-            raise ValueError("no backend for suffix %s" % suffix)
-        
-        ent = entries_backend[0]
-        if normalizeDN(suffix) != normalizeDN(ent.getValue('nsslapd-suffix')):
-            log.warning("enableReplication: suffix (%s) and backend suffix (%s) differs" % (suffix, entries_backend[0].nsslapd-suffix))
-            pass
-        
-        # Now prepare the bindDN property
-        if not binddn:
-            binddn = defaultProperties.get(REPLICATION_BIND_DN, None)
-            if not binddn:
-                # weird, internal error we do not retrieve the default replication bind DN
-                # this replica will not be updatable through replication until the binddn
-                # property will be set
-                log.warning("enableReplication: binddn not provided and default value unavailable")
-                pass
-            
-        # Now do the effectif job
-        # First add the changelog if master/hub
-        if (role == REPLICAROLE_MASTER) or (role == REPLICAROLE_HUB):
-            self.replica.changelog()
-            
-        # Second create the default replica manager entry if it does not exist
-        # it should not be called from here but for the moment I am unsure when to create it elsewhere
-        self.replica.create_repl_manager()
-        
-        # then enable replication
-        ret = self.replica.add(suffix=suffix, binddn=binddn, role=role, rid=replicaId)
-        
-        return ret
+
 
     def replicaSetupAll(self, repArgs):
         """setup everything needed to enable replication for a given suffix.
diff --git a/lib389/_constants.py b/lib389/_constants.py
index 35fbcf3..3557ec3 100644
--- a/lib389/_constants.py
+++ b/lib389/_constants.py
@@ -1,7 +1,7 @@
 # replicatype @see https://access.redhat.com/knowledge/docs/en-US/Red_Hat_Directory_Server/8.1/html/Administration_Guide/Managing_Replication-Configuring-Replication-cmd.html
 # 2 for consumers and hubs (read-only replicas)
 # 3 for both single and multi-master suppliers (read-write replicas)
-# TODO: let's find a way to be consistent - eg. using bitwise operator
+
 (MASTER_TYPE,
  HUB_TYPE,
  LEAF_TYPE) = range(3)
@@ -14,16 +14,27 @@ CONSUMER_REPLICAID = 65535
 
 REPLICA_RDONLY_TYPE = 2  # CONSUMER and HUB
 REPLICA_WRONLY_TYPE = 1  # SINGLE and MULTI MASTER
-REPLICA_RDWR_TYPE = REPLICA_RDONLY_TYPE | REPLICA_WRONLY_TYPE
+REPLICA_RDWR_TYPE   = REPLICA_RDONLY_TYPE | REPLICA_WRONLY_TYPE
 
-REPLICATION_BIND_DN = 'replication_bind_dn'
-REPLICATION_BIND_PW = 'replication_bind_pw'
+REPLICA_RUV_UUID    = "ffffffff-ffffffff-ffffffff-ffffffff"
+REPLICA_OC_TOMBSTONE= "nsTombstone"
+REPLICATION_BIND_DN     = 'replication_bind_dn'
+REPLICATION_BIND_PW     = 'replication_bind_pw'
 REPLICATION_BIND_METHOD = 'replication_bind_method'
+REPLICATION_TRANSPORT   = 'replication_transport'
+
+TRANS_STARTTLS  = "starttls"
+TRANS_SECURE    = "secure"
+TRANS_NORMAL    = "normal"
+REPL_TRANS_VALUE = {TRANS_STARTTLS: 'TLS',
+                    TRANS_SECURE:   'SSL',
+                    TRANS_NORMAL:   'LDAP'}
 
 defaultProperties = {
-    REPLICATION_BIND_DN: "cn=replrepl,cn=config",
-    REPLICATION_BIND_PW: "password",
-    REPLICATION_BIND_METHOD: "simple"
+    REPLICATION_BIND_DN:        "cn=replrepl,cn=config",
+    REPLICATION_BIND_PW:        "password",
+    REPLICATION_BIND_METHOD:    "simple",
+    REPLICATION_TRANSPORT:      REPL_TRANS_VALUE[TRANS_NORMAL]
 }
 
 
@@ -51,6 +62,8 @@ DEFAULT_BENAME      = 'userRoot'    # warning it is case sensitive
 DEFAULT_BACKUPDIR   = '/tmp'
 DEFAULT_INST_HEAD   = 'slapd-'
 DEFAULT_ENV_HEAD    = 'dirsrv-'
+DEFAULT_CHANGELOG_NAME = "changelog5"
+DEFAULT_CHANGELOG_DB   = 'changelogdb'
 
 PW_DM = "password"
 
@@ -76,6 +89,8 @@ DN_CHANGELOG    = "cn=changelog5,%s"    % DN_CONFIG
 DN_LDBM         = "cn=ldbm database,%s" % DN_PLUGIN
 DN_CHAIN        = "cn=chaining database,%s" % DN_PLUGIN
 
+RDN_REPLICA     = "cn=replica"
+
 
 
 #
diff --git a/lib389/_entry.py b/lib389/_entry.py
index 6e3dcd0..f993a36 100644
--- a/lib389/_entry.py
+++ b/lib389/_entry.py
@@ -4,6 +4,9 @@ from ldap.cidict import cidict
 import cStringIO
 
 import logging
+import ldap
+from lib389 import *
+from lib389.properties import *
 logging.basicConfig(level=logging.DEBUG)
 log = logging.getLogger(__name__)
 
@@ -176,3 +179,34 @@ class Entry(object):
         ldif.LDIFWriter(
             sio, Entry.base64_attrs, 1000).unparse(self.dn, newdata)
         return sio.getvalue()
+    
+    def create(self, type=ENTRY_TYPE_PERSON, entry_dn=None, properties=None):
+        """ Return - eventually creating - a person entry with the given dn and pwd.
+
+            binddn can be a lib389.Entry
+        """
+        if not entry_dn:
+            raise ValueError("entry_dn is mandatory")
+        
+        if not type:
+            raise ValueError("type is mandatory")
+
+        ent = Entry(entry_dn)
+        ent.setValues(ENTRY_OBJECTCLASS,  ENTRY_TYPE_TO_OBJECTCLASS[type])
+        ent.setValues(ENTRY_USERPASSWORD, properties.get(ENTRY_USERPASSWORD, ""))
+        ent.setValues(ENTRY_SN,           properties.get(ENTRY_SN, "bind dn pseudo user"))
+        ent.setValues(ENTRY_CN,           properties.get(ENTRY_CN, "bind dn pseudo user"))
+        if type == ENTRY_TYPE_INETPERSON:
+            ent.setValues(ENTRY_UID,      properties.get(ENTRY_UID, "bind dn pseudo user"))
+            
+        try:
+            self.add_s(ent)
+        except ldap.ALREADY_EXISTS:
+            log.warn("Entry %s already exists" % entry_dn)
+
+        try:
+            entry = self._test_entry(entry_dn, ldap.SCOPE_BASE)
+            return entry
+        except MissingEntryError:
+            log.exception("This entry should exist!")
+            raise
